<template>
  <div class="app-container">
    <el-form ref="postForm" :rules="formRules" :model="formData" label-width="150px">
      <el-form-item label="工地名称：" prop="site_name">
        <el-col :span="6">
          <el-input v-model="formData.site_name" placeholder="请输入工地名称"/>
        </el-col>
      </el-form-item>
      <el-form-item label="负责人名称：">
        <el-col :span="6">
          <el-input v-model="formData.site_man" placeholder="请输入负责人名称"/>
        </el-col>
      </el-form-item>
      <el-form-item label="负责人电话：" prop="man_phone">
        <el-col :span="6">
          <el-input v-model="formData.man_phone" placeholder="请输入负责人电话"/>
        </el-col>
      </el-form-item>
      <el-form-item label="工地地址：">
        <el-col :span="6">
          <el-input v-model="formData.site_address" placeholder="请输入工地地址"/>
        </el-col>
      </el-form-item>
      <el-form-item label="客户单位：" prop="client_id">
        <el-col :span="6">
          <el-select v-model="formData.client_id" placeholder="请选择" clearable>
            <el-option v-for="(item, index) in ClientList" 
              :key="index"
              :label="item.client_company" :value="item.client_id" >
            </el-option>
          </el-select>
        </el-col>
      </el-form-item>
      <el-form-item align="center">
        <el-button type="primary" @click="submitForm">保存</el-button>
        <el-button @click="onCancel">取消</el-button>
      </el-form-item>
    </el-form>
  </div>
</template>

<script>
import { checkRqInput, checkPwdLength, checkTel } from '@/utils/validate'
import { detailSite, updateSite, createSite, getClient  } from '@/api/base/index'

export default {
  name: 'ArticleDetail',
  // 配合路由配置的props属性实现在组件中通过props获取参数
  props: {
    id: {
      type: String,
      default() {
        return this.$route.params.id;
      }
    }
  },
  data() {
    return {
      formData: {
        man_phone: ''
      },
      // 校验规则
      formRules: {
        site_name: [ checkRqInput ],
        site_man: [ checkRqInput ],
        man_phone: [ checkTel ],
        site_address: [ checkRqInput ],
        client_id: [ checkRqInput ]
      },
      passwordValue: this.$props.id?false:true, // 密码按钮状态
      ClientList: [], // 客户单位列表
    }
  },
  created() {
    this.fetchClient()
    this.fetchDetail()
  },
  methods: {
    // 获取客户单位列表
    fetchClient() {
      this.$http(getClient(), (res) => {
        if (res.code == 0) {
          this.ClientList = res.data
        }
      })
    },
    // 获取企业详情
    fetchDetail() {
      const id = this.$props.id
      if (id) {
        this.$http(detailSite(id), (res) => {
          if (res.code == 0) {
            this.formData = res.data
          }
        })
      }
      this.formData.site_id = id
    },
    // 提交表单
    submitForm() {
      this.$refs['postForm'].validate((valid) => {
        if (valid) {
          // 修改
          if (this.formData.site_id) {
            this.$http(updateSite(this.formData), res => {
              this.$message({
                message: '成功',
                type: 'success'
              })
              this.$router.go(-1)
            })
          } else {
            // 新增
            this.$http(createSite(this.formData), res => {
              this.$message({
                message: '成功',
                type: 'success'
              })
              this.$router.go(-1)
            })
          }
        } else {
          return false
        }
      })
    },
    // 取消
    onCancel() {
      this.$message({
        message: '已取消!',
        type: 'warning'
      })
      this.$router.go(-1)
    },
  }
}
</script>

<style rel="stylesheet/scss" lang="scss" scoped>
</style>
